var COLORS = [
  "\033[34m", "\033[36m", "\033[32m", "\033[33m", "\033[31m", "\033[35m",
];

var LEVELS = [
  "TRACE", "DEBUG", "INFO", "WARN", "ERROR", "FATAL",
];

var LEVEL = 0;


function preInfo(l) {
  return COLORS[l] + "[" + (new Date()).toISOString() + "] [" + LEVELS[l] + "] default -\033[0m";
}


function common(level) {
  function fn() {
    if (level >= LEVEL)
      console.log.bind(null, preInfo(level)).apply(console, arguments);
  }
  return fn;
}


function setLevel(levelStr) {
  var i = LEVELS.indexOf(levelStr);
  if (i === -1)
    throw new Error("Unknown level string:" + levelStr);

  LEVEL = i;
}


module.exports = {
  trace: common(0),
  debug: common(1),
  info: common(2),
  warn: common(3),
  error: common(4),
  fatal: common(5),

  setLevel,
};
